@echo off

rundll32.exe user32.dll,LockWorkStation

rem --- Vars
set sys_drive=c:
set script_drive=%~d0%
set script_dir=%~f0%
set script_dir=%script_dir:~0,-12%postinst.d
set tmp_dir=%sys_drive%\opsi.org\tmp
set log_dir=%sys_drive%\opsi.org\log
set data_dir=%sys_drive%\opsi.org\data
set log_file=%log_dir%\postinst.log

rem --- Create temp dir
md %tmp_dir%
md %log_dir%
md %data_dir%

rem --- Start log file
echo [%date% %time%] Postinst.cmd starting >%log_file%

rem --- Copy scripts to temp dir
echo [%date% %time%] Copying script files from %script_dir% to %tmp_dir%\postinst.d >>%log_file%
md %tmp_dir%\postinst.d >>%log_file%
copy %script_dir%\*.cmd %tmp_dir%\postinst.d\ >>%log_file%
copy %script_dir%\*.opsiscript %tmp_dir%\postinst.d\ >>%log_file%
copy %script_dir%\*.xml %tmp_dir%\postinst.d\ >>%log_file%

rem --- Delete script backup files
del %tmp_dir%\postinst.d\*~ 2>nul


rem --- Enable powershell
ver | find "Version 5.1" >nul && goto nopowershell1
ver | find "Version 5.2" >nul && goto nopowershell1
echo [%date% %time%] Enable powershell >>%log_file%
powershell.exe set-executionpolicy RemoteSigned
copy %script_dir%\*.ps1 %tmp_dir%\postinst.d\ >>%log_file%
goto goon1
:nopowershell1
echo [%date% %time%] No powershell at NT5 >>%log_file%
:goon1

rem --- Sort scripts
dir /B "%tmp_dir%\postinst.d\*.cmd" "%tmp_dir%\postinst.d\*.ps1" | sort >%tmp_dir%\postinst.scripts
echo [%date% %time%] Listing available postinst scripts: >>%log_file%
for /F %%f in (%tmp_dir%\postinst.scripts) do (
	echo [%date% %time%]    %%f >>%log_file%
)

rem --- Execute scripts
echo [%date% %time%] Executing postinst scripts: >>%log_file%
rem --- Execute scripts 1
rem --- Enable delayed variable expansion to get correct times in the Log
SETLOCAL EnableDelayedExpansion
for /F %%f in (%tmp_dir%\postinst.scripts) do (
	echo [!date! !time!] Executing %tmp_dir%\postinst.d\%%f >>%log_file%
	if /I "%%~xf"==".cmd" call "%tmp_dir%\postinst.d\%%f" >>%log_file% 2>&1
	if /I "%%~xf"==".ps1" start /wait  powershell.exe -NonInteractive -WindowStyle hidden -file %tmp_dir%\postinst.d\%%f
)
pause
rem --- Disable powershell
rem powershell.exe set-executionpolicy Undefined
rem moved to 99_cleanup.cmd

rem --- Clean up
rmdir /S /Q %tmp_dir%\postinst.d
del %tmp_dir%\postinst.scripts

	
