rem --- Start mui installation
set mui_setup=%script_drive%\opsi\mui\muisetup.exe
set language_id=0407

if not exist "%mui_setup%" (
    echo [%date% %time%] Skipping mui installation - mui setup "%mui_setup%" not found
    goto skip
)
echo [%date% %time%] Starting mui installation - language id %language_id%

echo [%date% %time%] Executing: "%mui_setup%" /i %language_id% /d %language_id% /r /s
"%mui_setup%" /i %language_id% /d %language_id% /r /s

echo [%date% %time%] Setting mui language for current user and default user to: %language_id%
For /F "tokens=2* usebackq delims= " %%a IN (`reg QUERY "HKLM\Software\Microsoft\Windows NT\CurrentVersion\ProfileList" /v "ProfilesDirectory" ^| findstr "ProfilesDirectory"`) DO set profiles_dir=%%b
For /F "tokens=* usebackq delims=\" %%a IN (`echo %profiles_dir%`) DO set profiles_dir=%%a
For /F "tokens=2* usebackq delims= " %%a IN (`reg QUERY "HKLM\Software\Microsoft\Windows NT\CurrentVersion\ProfileList" /v "DefaultUserProfile" ^| findstr "DefaultUserProfile"`) DO set default_user_profile=%%b
if "%default_user_profile%" == "" set %default_user_profile%=Default

echo [%date% %time%] Loading default user registry "%profiles_dir%\%default_user_profile%\ntuser.dat"
reg load HKU\temp "%profiles_dir%\%default_user_profile%\ntuser.dat"

echo [%date% %time%] Patching registry
reg add "HKCU\Control Panel\Desktop" /f /v "MUILanguagePending" /t REG_SZ /d 0000%language_id%
reg add "HKCU\Control Panel\Desktop" /f /v "MultiUILanguageId" /t REG_SZ /d 0000%language_id%
reg add "HKU\temp\Control Panel\Desktop" /f /v "MUILanguagePending" /t REG_SZ /d 0000%language_id%
reg add "HKU\temp\Control Panel\Desktop" /f /v "MultiUILanguageId" /t REG_SZ /d 0000%language_id%
reg add "HKEY_USERS\.DEFAULT\Control Panel\Desktop" /f /v "MUILanguagePending" /t REG_SZ /d 0000%language_id%
reg add "HKEY_USERS\.DEFAULT\Control Panel\Desktop" /f /v "MultiUILanguageId" /t REG_SZ /d 0000%language_id%

echo [%date% %time%] Unloading default user registry
reg unload HKU\temp
:skip
