def prepareDisk():

    global inUefi
    global use_lvm
    global encrypt_lvm
    global useGpt
    global disk
    global target
    global source
    global depotsource
    global bootPartitionNumber
    global systemPartitionNumber
    global swapPartitionNumber
    global dataPartitionNumber
    global opsiserver
    global wget_and_execute
    global setupAfterInstall
    global install_opsi_client_agent
    global proxy
    global myarchitecture
    global systemPartitionDevicePath
    global swapPartitionDevicePath
    global swapPartitionSizeM
    global swapPartitionUUID
    global bootPartitionDevicePath
    global systemPartitionDevicePathUUID
    global swapPartitionDevicePathUUID
    global bootPartitionDevicePathUUID
    global lukslvmPartitionUUID

    target = '/mnt/hd'
    source = SCRIPT_PATH
    depotsource = DEPOT_MOUNT + '/' + SCRIPT_PATH

    use_lvm = True
    if (str(productProperties.get('use_logical_volumes', 'false')).lower() == 'false'):
        use_lvm = False

    encrypt_lvm = True
    if (str(productProperties.get('encrypt_logical_volumes', 'false')).lower() == 'false'):
        encrypt_lvm = False
    if encrypt_lvm:
        use_lvm = True

    useGpt = False
    inUefi = inUefiMode()
    if inUefi:
        useGpt = True

    if useGpt:
        logger.notice(u"Will use GPT")
    else:
        logger.notice(u"Will use MBR Partitions")

    if use_lvm:
        logger.notice(u"Will use Logical Volumes")
    else:
        logger.notice(u"Will use only Partitions (no Logical Volumes)")

    if encrypt_lvm:
        logger.notice(u"Will encrypt Logical Volumes")
    else:
        logger.notice(u"No Logical Volume encryption")

    # no boot partition support for linux without lvm
    bootPartitionNumber = 0
    bootPartitionDevicePath = None
    bootPartitionDevicePathUUID = None
    bootPartitionSize   = productProperties.get('boot_partition_size', '0')
    bootPartitionSizeM = int(bootPartitionSize.upper().replace('M', '').replace('G', '').replace('B', ''))
    if (bootPartitionSize.upper().find('G') != -1):
        bootPartitionSizeM *= 1024
    bootPartitionSizeM = 0
    bootPartitionLabel  = 'BOOT'
    bootPartitionLetter = "-"
    bootPartitionHidden = True

    if use_lvm:
        bootPartitionNumber = 1
        if bootPartitionSize == '0':
            logger.notice(u"Boot partition size cannot be 0 when using logical volumes, increasing to 400M")
            bootPartitionSize   = '1000M'
            bootPartitionSizeM = 1000
        bootPartitionLabel  = 'boot'
        bootPartitionLetter = "-"
        bootPartitionHidden = True

        lvmPartitionLabel  = 'LVM'
        lvmPartitionNumber = 2

    systemPartitionNumber = 1
    systemPartitionSize   = productProperties.get('system_partition_size', '100%')
    systemPartitionLabel  = productProperties.get('system_partition_label', 'linux')
    systemPartitionLetter = "C"
    systemPartitionSizeM = 0

    swapPartitionNumber = 2
    swapPartitionSize   = "2000M"
    swapPartitionSize   = productProperties.get('swap_partition_size', '2000M')
    swapPartitionLabel  = "swap"
    swapPartitionLetter = "X"

    dataPartitionNumber = 0
    dataPartitionLabel  = productProperties.get('data_partition_label', 'data')
    dataPartitionLetter = productProperties.get('data_partition_letter', 'D')
    dataPartitionCreate = True
    if (str(productProperties.get('data_partition_create', 'true')).lower() == 'false'):
        dataPartitionCreate = False

    blockAlignment = True
    #blockAlignment = False
    #if (str(productProperties.get('blockAlignment', 'true')).lower() == 'true'):
    #       blockAlignment = True

    #if (str(productProperties.get('swapnetworkmode', 'true')).lower() == 'false'):
    #       swapNetworkMode = False

    useRaid1 = False
    #if (str(productProperties.get('use_raid1', 'false')).lower() == 'true'):
    #       useRaid1 = True

    if dataPartitionCreate and (systemPartitionSize != "100%"):
        dataPartitionNumber = 3

    opsiserver = False
    if (str(productProperties.get('install_opsi_server', 'true')).lower() == 'true'):
        opsiserver = True


    wget_and_execute = productProperties.get('wget_and_execute', '')
    wget_and_execute = wget_and_execute.strip()

    setupAfterInstall = productPropertyValues.get('setup_after_install', '')
    proxy = productProperties.get('proxy','')

    install_opsi_client_agent = False
    if (str(productProperties.get('install_opsi-client-agent', 'true')).lower() == 'true'):
        install_opsi_client_agent = True

    if not bootPartitionSize.startswith("0"):
        bootPartitionNumber = 1
        systemPartitionNumber += 1
        swapPartitionNumber += 1
        if (dataPartitionNumber > 0):
            dataPartitionNumber += 1

    if inUefi:
        systemPartitionNumber += 2
        swapPartitionNumber += 2
        if use_lvm:
            lvmPartitionNumber += 2
        if not bootPartitionSize.startswith("0"):
            bootPartitionNumber += 2
        if (dataPartitionNumber > 0):
            dataPartitionNumber += 2
    logger.notice("Partition numbers are now: boot=%d, system=%d, swap=%d, data=%s" % (bootPartitionNumber, systemPartitionNumber, swapPartitionNumber, dataPartitionNumber))

    # check if it is allowed to delete the partition table
    dataPartitionPreserve = 'never'
    if (str(productProperties.get('data_partition_preserve', 'never')).lower() == 'if_possible'):
        dataPartitionPreserve = 'if_possible'
    if (str(productProperties.get('data_partition_preserve', 'never')).lower() == 'always'):
        dataPartitionPreserve = 'always'

    # get machine architecture
    myarchitecture = getArchitecture()
    if myarchitecture == 'amd64':
        scriptMessageSubject.setMessage(u"Installing 64 Bit system....")
        logger.notice(u"Installing 64 Bit system....")
    else:
        scriptMessageSubject.setMessage("Installing 32 Bit system....")
        logger.notice(u"Installing 32 Bit system....")

# end of def collectPrepareData

    logger.notice(u"Swapoff all to avoid disk in use .....")
    execute("swapoff -a -v")
    lvmClearVolumeGroups()
    try:
        execute("cryptsetup remove lukslvm")
    except:
        pass

    # Get harddisks
    disks = getHarddisks()
    #os.putenv("LD_PRELOAD", "")

    disks = sorted(disks, key=lambda disk: disk.device)
    # use first disk
    partition_disk = productProperties.get('partition_disk', 'first')
    showDiskOrder(disks)
    if partition_disk == "first":
        disk = disks[0]
    else:
        for currentDisk in disks:
            if currentDisk.device == partition_disk:
                logger.notice("currentDisk %s is the same as desired disk %s" % (currentDisk.device, partition_disk))
                disk = currentDisk
            else:
                logger.notice("currentDisk %s and partition_disk %s do not match" % (currentDisk.device, partition_disk))

    # Calculate partitions
    diskSizeM = (float(disk.size)/(1024*1024))
    diskTotalSectors = disk.sectors

    if not bootPartitionSize.startswith("0"):
        # Create boot partition
        bootPartitionSizeM = int(bootPartitionSize.upper().replace('M', '').replace('G', '').replace('B', ''))
        if (bootPartitionSize.upper().find('G') != -1):
            bootPartitionSizeM *= 1024
        logger.notice(u"Required Boot partition (%d) size is %dM" % (bootPartitionNumber, bootPartitionSizeM))

    swapPartitionSizeM = int(swapPartitionSize.upper().replace('M', '').replace('G', '').replace('B', ''))
    if (swapPartitionSize.upper().find('G') != -1):
        swapPartitionSizeM *= 1024
    logger.notice(u"Required swap partition (%d) size is %dM" % (swapPartitionNumber, swapPartitionSizeM))

    peStartM = int(diskSizeM - swapPartitionSizeM)
    boundaryM = int(diskSizeM)
    systemPartitionSizeM = int(diskSizeM - bootPartitionSizeM - swapPartitionSizeM - 1000)
    if (systemPartitionSize != "100%"):
        sizeM = 0
        if (systemPartitionSize.find('%') != -1):
            percent = int(systemPartitionSize.replace('%', ''))
            sizeM = int((float(percent)/100.0)*float(diskSizeM-bootPartitionSizeM))
        else:
            sizeM = int(systemPartitionSize.upper().replace('M', '').replace('G', '').replace('B', ''))
            if (systemPartitionSize.upper().find('G') != -1):
                sizeM *= 1024
        dataSizeM = diskSizeM - sizeM
        systemPartitionSizeM = int(sizeM - 1000)
        logger.notice(u"Required system partition (%s) size is %dM, data partition (%d) size is %dM" \
                % (systemPartitionNumber, sizeM, dataPartitionNumber, dataSizeM))
        if (dataSizeM <= 0):
            raise Exception(u"Not enough disk space for required system partition size %dM" % sizeM)
        boundaryM = bootPartitionSizeM + sizeM
        peStartM = boundaryM - swapPartitionSizeM
        ui
    # should we preserve the partition table ?
    if (dataPartitionPreserve == 'never'):
        will_create_new_partition_table = True
    else:
        will_create_new_partition_table = False

        # Get current partitions
        partitions = disk.getPartitions()

        if not partitions:
            # No partition found on harddisk
            scriptMessageSubject.setMessage(u"Found no partitions on %s " % disk.device)
            logger.notice(u"Found no partitions on %s " % disk.device)
            # nothing to preserve
            will_create_new_partition_table = True
        else:
            if (systemPartitionSize == "100%"):
                scriptMessageSubject.setMessage(u"Ignoring dataPartitionPreserve = %s because we have a required systemPartitionSize = 100 percent" % disk.device)
                logger.notice(u"Ignoring dataPartitionPreserve = %s because we have a required windowsPartitionSize = 100 percent" % disk.device)
                will_create_new_partition_table = True
            else:
                # we have a partition table and we should preserve it
                # is it possible ?
                if not useGpt:
                    fdiskexitcode = os.system("echo %s1 : start=0, size=0 | sfdisk %s >> /dev/null 2>&1" % (disk.device,disk.device))
                    fdiskexitcode = os.system("sfdisk -V %s >> /dev/null 2>&1" % (disk.device))
                    if (0 != int(fdiskexitcode)):
                        logger.notice(u"disk %s have no usable legacy partition table" % (disk.device))
                        will_create_new_partition_table = True
                    else:
                        logger.notice(u"disk %s has a usable legacy partition table" % (disk.device))
                        # compare existing sizes  with calculated requirements
                        if not bootPartitionSize.startswith("0"):
                            # we should have a bootpartion
                            try:
                                SizeP = int(float(disk.getPartition(bootPartitionNumber).get("size"))/(1024*1024))
                                logger.notice(u"Existing boot partition size = %s" % SizeP)
                            except:
                                logger.notice(u"boot partition (%d) seems not to exist" % (bootPartitionNumber))
                                SizeP = 0
                            # tolerance 50 M
                            if (abs(bootPartitionSizeM - SizeP) > 50):
                                logger.notice(u"Existing boot partition size %s does not match on required size %dM" % (SizeP, bootPartitionSizeM))
                                will_create_new_partition_table = True

                        # check system partition
                        freespaceM = 0
                        try:
                            SizeP = int(float(disk.getPartition(systemPartitionNumber).get("size"))/(1024*1024))
                            logger.notice(u"Existing system partition size = %s" % SizeP)
                        except:
                            logger.notice(u"System partition (%d) seems not to exist" % (systemPartitionNumber))
                            SizeP = 0
                            freespaceM = int(partitions[1]['end'] / (1024*1024))
                            logger.notice(u"We have a free space of %sM before partition 2" % (freespaceM))
                        try:
                            SizePe = int(float(disk.getPartition(swapPartitionNumber).get("size"))/(1024*1024))
                            logger.notice(u"Existing swap partition size = %s" % SizePe)
                        except:
                            logger.notice(u"swap partition (%d) seems not to exist" % (swapPartitionNumber))
                            SizePe = 0
                        # tolerance 5G
                        if (abs(systemPartitionSizeM - (SizeP + SizePe + freespaceM)) > 5000):
                            logger.notice(u"Existing free space, system (and swap) partition size %d does not match the required size %dM" % ((SizeP+SizePe + freespaceM), systemPartitionSizeM))
                            will_create_new_partition_table = True
                        else:
                            logger.notice(u"Existing free space, system (and swap) partition size %d match the required size %dM" % ((SizeP+SizePe + freespaceM), systemPartitionSizeM))
                else:
                    logger.notice("has disk %s a usable gpt partition table ?" % (disk.device))
                    fdiskexitcode = os.system("sgdisk -p %s >> /tmp/gpt.log 2>&1" % (disk.device))
                    if (0 != int(fdiskexitcode)):
                        logger.notice(u"disk %s have no usable gpt partition table" % (disk.device))
                        will_create_new_partition_table = True

                if will_create_new_partition_table:
                    if (dataPartitionPreserve == 'always'):
                        # we have to stop here
                        scriptMessageSubject.setMessage(u"Could not use the existing partition table on %s - but not allowed to delete it - stopping here" % (disk.device))
                        raise Exception(u"Could not use the existing partition table on %s - but not allowed to delete it - stopping here" % (disk.device))
                    else:
                        scriptMessageSubject.setMessage(u"Could not use the existing partition table on %s - but allowed to delete it - going on" % (disk.device))
                else:
                    scriptMessageSubject.setMessage(u"Will use the existing partition table on %s - going on" % (disk.device))



    # create mount point before loop
    checkClearMountpoint("%s/proc" % target, "none", "none")
    checkClearMountpoint("%s/sys" % target, "none", "none")
    checkClearMountpoint("%s/dev" % target, "none", "none")
    checkClearMountpoint("%s" % target, "none", "none")
    execute("swapoff -a")
    checkCreateDir(target)

    if not useGpt:
        fdiskexitcode = os.system("echo %s1 : start=0, size=0 | sfdisk %s >> /dev/null 2>&1" % (disk.device,disk.device))
        fdiskexitcode = os.system("sfdisk -V %s >> /dev/null 2>&1" % (disk.device))
        if (0 != int(fdiskexitcode)):
            if (dataPartitionPreserve == 'always'):
                raise Exception(u"Could not use the existing partition table on %s - but not allowed to delete it - stopping here" % (disk.device))
            else:
                logger.notice(u"using sgdisk to clear not usable partition table of %s" % (disk.device))
                execute('/usr/sbin/sgdisk --zap-all %s' % (disk.device))
                fdiskexitcode = os.system("echo %s1 : start=0, size=0 | sfdisk %s >> /dev/null 2>&1" % (disk.device,disk.device))
                scriptMessageSubject.setMessage(u"Deleted partition Table on %s - Perhaps you need a restart....." % (disk.device))
    else:
        # todo: if (delete_partition_table == 'never'):
        logger.notice(u"using sgdisk to clear partition table of %s" % (disk.device))
        execute('/usr/sbin/sgdisk --zap-all %s' % (disk.device))

    fdiskexitcode = os.system('%s %s >> /dev/null 2>&1' % (which('partprobe'), disk.device))
    # Write Master Boot Record
    #disk.writeMasterBootRecord(system = 'vista')

    if not useGpt:
        if blockAlignment:
            disk.setBlockAlignment(blockAlignment)

    scriptMessageSubject.setMessage(u"Using harddisk %s (%0.0f MB)." % (disk.device, (float(disk.size)/(1024*1024))))

    # Check disk size
    if (disk.size < 5000*1024*1024):
        # Disk smaller than 5000 MB => give up
        raise Exception(u"Disk to small")

    # Get current partitions
    partitions = disk.getPartitions()

    if not partitions:
        # No partition found on harddisk
        scriptMessageSubject.setMessage(u"Found no partitions on %s" % disk.device)

    if will_create_new_partition_table:
        # Create new partitiontable
        if useGpt:
            logger.notice(u"Clear partition table of %s" % (disk.device))
            execute('/usr/sbin/sgdisk --zap-all %s' % (disk.device))
            execute('/usr/sbin/sgdisk --clear -g -p %s' % (disk.device))
            if inUefi:
                logger.notice(u"Create EFI system partition on %s1" % (disk.device))
                execute('/usr/sbin/sgdisk -g --new 1::400M -t 1:ef00 -c 1:\"EFI system partition\" --partition-guid=C12A7328-F81F-11D2-BA4B-00A0C93EC93B -p %s' % (disk.device))
                execute('/bin/sleep 2')
                execute('/usr/sbin/sgdisk -p %s' % (disk.device))
                logger.notice(u"Make file system on EFI system partition on %s1" % (disk.device))
                if (disk.device.startswith('/dev/sd')) or (disk.device.startswith('/dev/vd')):
                    execute('/sbin/mkfs.vfat %s1' % (disk.device))
                else:
                    execute('/sbin/mkfs.vfat %sp1' % (disk.device))
                logger.notice(u"Create MS reserved partition on %s2" % (disk.device))
                execute('/usr/sbin/sgdisk -g --new 2::+128M -t 2:0c01 -c 2:\"MS reserved\" --partition-guid=E3C9E316-0B5C-4DB8-817D-F92DF00215AE -p %s' % (disk.device))
        else:
            disk.deletePartitionTable()
            # Write Master Boot Record
            #disk.writeMasterBootRecord(system = 'vista')
    else:
        logger.notice(u"we reuse the existing partitiontable")
        if useGpt:
            if not bootPartitionSize.startswith("0"):
                logger.notice(u"Delete Partitions ...")
                execute('/usr/sbin/sgdisk -g --delete=partnum %d -p %s' % (bootPartitionNumber, disk.device))
                execute('/usr/sbin/sgdisk -g --delete=partnum %d -p %s' % (systemPartitionNumber, disk.device))
                execute('/usr/sbin/sgdisk -g --delete=partnum %d -p %s' % (swapPartitionNumber, disk.device))
            else:
                logger.notice(u"Delete Partitions ...")
                execute('/usr/sbin/sgdisk -g --delete=partnum %d -p %s' % (systemPartitionNumber, disk.device))
        else:
            if not bootPartitionSize.startswith("0"):
                # boot
                disk.deletePartition (bootPartitionNumber)
                # system
                disk.deletePartition (systemPartitionNumber)
                # swap
                disk.deletePartition (swapPartitionNumber)
            else:
                # system
                disk.deletePartition (systemPartitionNumber)

            # swap
            exitcode = os.system("test -b %s >> /dev/null 2>&1" % (getPartitionDevicePath(disk.device, swapPartitionNumber)))
            if (0 == int(exitcode)):
                partitionLabel = partitionHasLabel(disk.device, swapPartitionNumber)
                #partitionLabel = 'unknown'
                #resultlist = execute(u'blkid -o value -s LABEL %s%s' % (disk.device, swapPartitionNumber) )
                #for resultline in resultlist:
                #       try:
                #               partitionLabel = resultline.strip()
                #       except:
                #               pass
                logger.notice(u"%s exists as device with label: %s" % (getPartitionDevicePath(disk.device, swapPartitionNumber), partitionLabel) )
                if (partitionLabel == 'swap'):
                    logger.notice(u"%s exists as expected - removing it" % (getPartitionDevicePath(disk.device, swapPartitionNumber)))
                    if useGpt:
                        execute('/usr/sbin/sgdisk -g --delete=partnum %d -p %s' % (swapPartitionNumber, disk.device))
                    else:
                        disk.deletePartition (2)
                else:
                    # device exists and label not data
                    if (partitionLabel == dataPartitionLabel):
                        logger.notice(u"%s exists as expected for device %s - ok " % (getPartitionDevicePath(disk.device, swapPartitionNumber), getPartitionDevicePath(disk.device,dataPartitionNumber)))
                    else:
                        logger.notice(u"%s exists but not as expected - not ok, but try to go on" % (getPartitionDevicePath(disk.device, swapPartitionNumber)))
            else:
                logger.notice(u"%s does not exists as device - ok" % (getPartitionDevicePath(disk.device, swapPartitionNumber)))


            # Write Master Boot Record
            #disk.writeMasterBootRecord(system = 'vista')


    # Partition table deleted => delete all netboot product states
    backend.backend_setOptions( { 'addProductPropertyStateDefaults': False } )
    deletePocs = []
    for poc in backend.productOnClient_getObjects(clientId = clientId):
        if ((poc.productType == 'NetbootProduct') and (poc.productId != productId)) or \
           ((poc.productType == 'LocalbootProduct') and (poc.installationStatus == 'not_installed') and (poc.actionRequest == 'none')):
            deletePocs.append(poc)
    backend.productOnClient_deleteObjects(deletePocs)

    # Create partitions
    if not bootPartitionSize.startswith("0"):
        createPartitionEx("boot", bootPartitionNumber, bootPartitionLabel, 0, int(bootPartitionSizeM), gptAutoAppend = True, boot = True, gptAttribute = "" , useGpt = useGpt, diskDevice = disk.device, fileSystem = "ext4", gptFileSystem="8300")

    if use_lvm:
        # Create lvm partition
        createPartitionEx("lvm", lvmPartitionNumber, lvmPartitionLabel, 0, -1, gptAutoAppend = True, boot = False, gptAttribute = "" , useGpt = useGpt, diskDevice = disk.device, fileSystem = "ext4", gptFileSystem="8300")
        if encrypt_lvm:
            with open( os.path.join('/tmp', 'key'), 'w' ) as tmpkey:
                tmpkey.write(productProperties.get('encrypt_password', 'linux123').strip())
            cryptpassword = productProperties.get('encrypt_password', 'linux123').strip()
            #execute('cryptsetup -c aes-xts-plain64 -s 512 -h sha512 --batch-mode --key-file="/tmp/key" luksFormat %s%d' % (disk.device, lvmPartitionNumber))
            #execute('cryptsetup --batch-mode --key-file="/tmp/key" luksFormat %s%d' % (disk.device, lvmPartitionNumber))
            #execute('cryptsetup  --key-file="/tmp/key" luksOpen %s%d lukslvm ' % (disk.device, lvmPartitionNumber))
            #execute('cryptsetup --key-file="/tmp/key" --batch-mode luksAddKey %s%d "/tmp/key"' % (disk.device, lvmPartitionNumber))
            execute('echo "%s" | cryptsetup --batch-mode luksFormat %s' % (cryptpassword,getPartitionDevicePath(disk.device, lvmPartitionNumber)))
            execute('echo "%s" | cryptsetup luksOpen %s lukslvm ' % (cryptpassword,getPartitionDevicePath(disk.device, lvmPartitionNumber)))

            resultlist = execute('cryptsetup luksUUID %s' % (getPartitionDevicePath(disk.device, lvmPartitionNumber)))
            for resultline in filter(None,resultlist):
                try:
                    lukslvmPartitionUUID = resultline.strip()
                except:
                    pass
            execute('pvcreate /dev/mapper/lukslvm')
            execute('vgcreate vglvm /dev/mapper/lukslvm')
            execute('lsmod')
        else:
            execute('pvcreate %s' % (getPartitionDevicePath(disk.device, lvmPartitionNumber)))
            execute('vgcreate vglvm %s' % (getPartitionDevicePath(disk.device, lvmPartitionNumber)))

        if int(swapPartitionSizeM) > 0:
            # Create swap partition
            execute('lvcreate -Wy -Zy --yes -L %s -n %s vglvm' % (swapPartitionSize, swapPartitionLabel))

        # Create system partition
        execute('lvcreate -Wy -Zy --yes -l %s -n %s vglvm' % ('100%FREE', systemPartitionLabel))

        bootPartitionDevicePath = getPartitionDevicePath(disk.device, bootPartitionNumber)
        systemPartitionDevicePath = "/dev/mapper/vglvm-%s" % systemPartitionLabel
        swapPartitionDevicePath = "/dev/mapper/vglvm-%s" % swapPartitionLabel

        # Create ext4 filesystem on boot partition
        logger.notice(u"Create ext4 filesystem on boot partition")
        createFilesystemEx("boot", "", bootPartitionLabel, "ext4", disk.device , useGpt, bootPartitionDevicePath)

        # Create ext4 filesystem on system partition
        logger.notice(u"Create ext4 filesystem on system partition")
        createFilesystemEx("system", "", systemPartitionLabel, "ext4", disk.device , useGpt, systemPartitionDevicePath)

        # create swap
        #testPartitionEx(diskDevice = "/dev/mapper/vglvm-swap", partitionNumber = "", useGpt = useGpt):
        if int(swapPartitionSizeM) > 0:
            logger.notice(u"Create swap and swapon swap partition")
            execute("mkswap -L %s %s" % (swapPartitionLabel, swapPartitionDevicePath) )

        execute("blkid")
        resultlist = execute(u'blkid -o value -s UUID %s' % (systemPartitionDevicePath) )
        for resultline in filter(None,resultlist):
            try:
                systemPartitionUUID = resultline.strip()
            except:
                pass
        systemPartitionDevicePathUUID = "UUID=%s" % (systemPartitionUUID)
        if int(swapPartitionSizeM) > 0:
            resultlist = execute(u'blkid -o value -s UUID %s' % (swapPartitionDevicePath) )
            for resultline in filter(None,resultlist):
                try:
                    swapPartitionUUID = resultline.strip()
                except:
                    pass 
            swapPartitionDevicePathUUID = "UUID=%s" % (swapPartitionUUID)
        resultlist = execute(u'blkid -o value -s UUID %s' % (bootPartitionDevicePath) )
        for resultline in filter(None,resultlist):
            try:
                bootPartitionUUID = resultline.strip()
            except:
                pass
        bootPartitionDevicePathUUID = "UUID=%s" % (bootPartitionUUID)

    else:
        if not bootPartitionSize.startswith("0"):
            bootPartitionDevicePath = getPartitionDevicePath(disk.device, bootPartitionNumber)
            resultlist = execute(u'blkid -o value -s UUID %s' % (bootPartitionDevicePath) )
            for resultline in filter(None,resultlist):
                try:
                    bootPartitionUUID = resultline.strip()
                except:
                    pass
            bootPartitionDevicePathUUID = "UUID=%s" % (bootPartitionUUID)
        # Create system partition
        createPartitionEx("system", systemPartitionNumber, systemPartitionLabel, 0, systemPartitionSizeM, gptAutoAppend = True, boot = True, gptAttribute = "" , useGpt = useGpt, diskDevice = disk.device, fileSystem = "ext4", gptFileSystem="8300")
        if int(swapPartitionSizeM) > 0:
                # Create swap partition
            createPartitionEx("swap", swapPartitionNumber, swapPartitionLabel, peStartM, swapPartitionSizeM, gptAutoAppend = True, boot = False, gptAttribute = "" , useGpt = useGpt, diskDevice = disk.device, fileSystem = "linux-swap", gptFileSystem="8200")

        if dataPartitionCreate and (dataPartitionNumber > 0):
            # Create data partition
            createPartitionEx("data", dataPartitionNumber, dataPartitionLabel, int(boundaryM), int(-1), gptAutoAppend = True, boot = False, gptAttribute = "" , useGpt = useGpt, diskDevice = disk.device, fileSystem = "ext4", gptFileSystem="8300")

        if not useGpt:
            partitions = disk.getPartitions()


        # Create ext4 filesystem on system partition
        logger.notice(u"Create ext4 filesystem on system partition")
        createFilesystemEx("system", systemPartitionNumber, systemPartitionLabel, "ext4", disk.device , useGpt)

        # create swap
        # HACK for error: /dev/sda2 not found: should be fixed in Library
        if not os.path.exists("%s" % (getPartitionDevicePath(disk.device, swapPartitionNumber))):
            exitcode = os.system('%s %s >> /dev/null 2>&1' % (which('partprobe'), disk.device))
            execute('/bin/sleep 2')
        if int(swapPartitionSizeM) > 0:
            logger.notice(u"Create swap and swapon swap partition")
            execute("mkswap -L %s %s" % (swapPartitionLabel, getPartitionDevicePath(disk.device, swapPartitionNumber)))

        systemPartitionDevicePath = getPartitionDevicePath(disk.device, systemPartitionNumber)
        logger.notice(u"system PartitionDevicePath = %s" % systemPartitionDevicePath)
        swapPartitionDevicePath = getPartitionDevicePath(disk.device, swapPartitionNumber)
        logger.notice(u"swap PartitionDevicePath = %s" % swapPartitionDevicePath)
        resultlist = execute(u'blkid -o value -s UUID %s' % (systemPartitionDevicePath) )
        for resultline in filter(None,resultlist):
            try:
                systemPartitionUUID = resultline.strip()
            except:
                pass
        systemPartitionDevicePathUUID = "UUID=%s" % (systemPartitionUUID)
        if int(swapPartitionSizeM) > 0:
            resultlist = execute(u'blkid -o value -s UUID %s' % (swapPartitionDevicePath) )
            for resultline in filter(None,resultlist):
                try:
                    swapPartitionUUID = resultline.strip()
                except:
                    pass
            swapPartitionDevicePathUUID = "UUID=%s" % (swapPartitionUUID)


        if dataPartitionCreate and (dataPartitionNumber > 0):
            createFilesystemEx("data", dataPartitionNumber, dataPartitionLabel, "ext4", disk.device, useGpt)

    if inUefi:
        currentbootentry = uefiGetActBootEntry()
        if currentbootentry:
            uefiNetbootLabel = currentbootentry['label']
            logger.notice('Current (net) boot entry: %s' % uefiNetbootLabel)
            backend.config_createUnicode("clientConfig.uefiNetbootLabel","clientspecific uefi firmware netboot entry label")
            backend.configState_create("clientConfig.uefiNetbootLabel", clientId, [ uefiNetbootLabel ] )
        else:
            logger.notice('No usable current (net) boot entry found')

# end of prepareDisk

# final functions
def handle_wget_and_execute():
    if (wget_and_execute != ''):
        cmds = []
        scriptMessageSubject.setMessage("Run wget_and_execute...")
        logger.notice(u"Run wget_and_execute...")
        cmds.append("cd /tmp")
        cmds.append("wget %s" % wget_and_execute)
        file2run = basename(urlparse(wget_and_execute).path)
        cmds.append("chmod u+x /tmp/%s" % file2run)
        cmds.append("/tmp/%s" % file2run)

        doChrooted( target, cmds, proxy, no_proxy)
        execute('/bin/sleep 5')

# end of handle_wget_and_execute

def unmountDisk():
    try:
        # Umount harddisk
        os.chdir("/")
        execute("mount")
        execute("lsof %s/proc" % target)
        execute("lsof %s/dev" % target)
        execute("lsof %s" % target)
        unmountexitcode = os.system("umount %s/boot" % target)
        unmountexitcode = os.system("umount %s/proc" % target)
        #execute("umount %s/proc" % target)
        #execute("umount %s/dev" % target)
        unmountexitcode = os.system("umount %s/dev" % target)
        if (0 != int(unmountexitcode)):
            logger.notice(u"umount failed - retrying....")
            execute('/bin/sleep 10')
            unmountexitcode = os.system("umount %s/dev" % target)
            if (0 != int(unmountexitcode)):
                logger.notice(u"umount failed - retrying....")
                execute('/bin/sleep 30')
                unmountexitcode = os.system("umount %s/dev" % target)
                if (0 != int(unmountexitcode)):
                    logger.error(u"umount failed - giving up....")
        execute("umount %s/sys" % target)
        # cleanup
        execute("rm -r %s/tmp/*" % target)
        exitcode = os.system("umount %s" % target)
        execute("mount")
    except:
        pass
    try:
        execute("umount --all")
    except:
        pass

# end of unmountDisk

# second step function
def handle_setupAfterInstall():
    if install_opsi_client_agent:
        handle_win_setupAfterInstall()
        #productsToDelete = backend.productOnClient_getObjects(clientId=clientId)
        #if productsToDelete:
        #       backend.productOnClient_deleteObjects(productsToDelete)

        #if setupAfterInstall:
        #       for setupProduct in setupAfterInstall:
        #               setupProduct = setupProduct.strip()
        #               if setupProduct != '':
        #                       logger.notice(u"Set to setup %s" % (setupProduct) )
        #                       backend.setProductActionRequestWithDependencies(productId=setupProduct, clientId=clientId, actionRequest='setup')

# end of handle_setupAfterInstall
